<?php

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

if($blog_id !== false){
  switch_to_blog($blog_id);
}
if(get_option('smpush_version') > 0){
  if($blog_id !== false){
    restore_current_blog();
  }
  return;
}

global $wpdb, $wp_rewrite;

$wpdb->hide_errors();

require_once(ABSPATH.'wp-admin/includes/upgrade.php');

$dbEngineISAM = 'MyISAM';
$dbEngineINNO = 'InnoDB';

$innodb = $wpdb->get_var('SELECT SUPPORT FROM INFORMATION_SCHEMA.ENGINES WHERE ENGINE="InnoDB"');
if($innodb == 'NO'){
  $dbEngineINNO = 'MyISAM';
}

$myisamdb = $wpdb->get_var('SELECT SUPPORT FROM INFORMATION_SCHEMA.ENGINES WHERE ENGINE="MyISAM"');
if($myisamdb == 'NO'){
  $dbEngineISAM = 'InnoDB';
}

$sql = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."push_archive` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `platforms` VARCHAR(200) NOT NULL,
  `name` VARCHAR(200) NOT NULL,
  `send_type` VARCHAR(15) NOT NULL,
  `message` TEXT NOT NULL,
  `starttime` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `endtime` datetime DEFAULT NULL,
  `repeat_interval` SMALLINT NOT NULL,
  `repeat_age` VARCHAR(15) NOT NULL,
  `options` LONGTEXT NULL DEFAULT NULL,
  `desktop` varchar(50) NOT NULL,
  `latitude` DECIMAL(10,8) NULL,
  `longitude` DECIMAL(11,8) NULL,
  `radius` MEDIUMINT NOT NULL,
  `gps_expire_time` SMALLINT NOT NULL,
  `status` BOOLEAN NOT NULL,
  `processed` BOOLEAN NOT NULL,
  PRIMARY KEY (`id`)
  ) ENGINE=$dbEngineINNO DEFAULT CHARSET=utf8";
dbDelta($sql);
$sql = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."push_archive_reports` (
  `msgid` int(11) NOT NULL,
  `report_time` varchar(15) NOT NULL,
  `report` text NOT NULL,
  KEY `msgid` (`msgid`)
  ) ENGINE=$dbEngineINNO DEFAULT CHARSET=utf8";
dbDelta($sql);
$sql = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."push_feedback` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `tokens` longtext NOT NULL,
  `feedback` longtext NOT NULL,
  `device_type` set('ios','android','ios_invalid','chrome','firefox') NOT NULL,
  `msgid` INT NOT NULL,
  `timepost` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
  ) ENGINE=$dbEngineINNO DEFAULT CHARSET=utf8";
dbDelta($sql);
$sql = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."push_statistics` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` date NOT NULL,
  `platid` VARCHAR(20) NOT NULL,
  `msgid` INT NOT NULL,
  `action` varchar(10) NOT NULL,
  `stat` int(11) NOT NULL,
  PRIMARY KEY (`id`)
  ) ENGINE=$dbEngineINNO DEFAULT CHARSET=utf8";
dbDelta($sql);
$sql = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."push_queue` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `token` varchar(255) NOT NULL,
  `device_type` varchar(10) NOT NULL,
  `counter` SMALLINT NOT NULL,
  `feedback` tinyint(1) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `device_type` (`device_type`)
  ) ENGINE=$dbEngineISAM DEFAULT CHARSET=utf8;";
dbDelta($sql);
$sql = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."push_cron_queue` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `token` varchar(255) NOT NULL,
  `device_type` varchar(10) NOT NULL,
  `counter` SMALLINT NOT NULL,
  `sendtime` varchar(15) NOT NULL,
  `sendoptions` int(11) NOT NULL,
  `timepost` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`),
  KEY `sendtime` (`sendtime`),
  KEY `device_type` (`device_type`),
  KEY `sendoptions` (`sendoptions`)
  ) ENGINE=$dbEngineISAM DEFAULT CHARSET=utf8";
dbDelta($sql);
$sql = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."push_tokens` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userid` int(11) NOT NULL,
  `device_token` varchar(255) NOT NULL,
  `md5device_token` varchar(32) NOT NULL,
  `device_type` VARCHAR(10) NOT NULL,
  `information` TINYTEXT NOT NULL,
  `latitude` DECIMAL(10, 8) NOT NULL,
  `longitude` DECIMAL(11, 8) NOT NULL,
  `gps_time_update` VARCHAR(15) NOT NULL,
  `last_geomsg_time` VARCHAR(15) NOT NULL DEFAULT '0',
  `receive_again_at` VARCHAR(15) NOT NULL DEFAULT '0',
  `timepost` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
  `counter` SMALLINT NOT NULL,
  `active` BOOLEAN NOT NULL,
  PRIMARY KEY (`id`),
  KEY `userid` (`md5device_token`)
  ) ENGINE=$dbEngineINNO DEFAULT CHARSET=utf8;";
dbDelta($sql);
$sql = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."push_channels` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(50) NOT NULL,
  `description` mediumtext NOT NULL,
  `private` tinyint(1) NOT NULL,
  `default` tinyint(1) NOT NULL,
  `count` int(11) NOT NULL,
  PRIMARY KEY (`id`)
  ) ENGINE=$dbEngineISAM DEFAULT CHARSET=utf8;";
dbDelta($sql);
$sql = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."push_relation` (
  `channel_id` int(11) NOT NULL,
  `token_id` int(11) NOT NULL,
  `userid` INT NOT NULL,
  KEY `channel_id` (`channel_id`)
  ) ENGINE=$dbEngineINNO DEFAULT CHARSET=utf8;";
dbDelta($sql);
$sql = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."push_events` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `title` varchar(200) NOT NULL,
    `event_type` varchar(50) NOT NULL,
    `post_type` varchar(50) NOT NULL,
    `subject` varchar(200) NOT NULL,
    `message` text NOT NULL,
    `fbmsn_message` text NOT NULL,
    `fbnotify_message` text NOT NULL,
    `email_message` text NOT NULL,
    `notify_segment` varchar(50) NOT NULL,
    `userid_field` varchar(100) NOT NULL,
    `conditions` text NOT NULL,
    `subs_filter` VARCHAR(10) NOT NULL,
    `payload_fields` TEXT NOT NULL,
    `msg_template` INT NOT NULL,
    `desktop_link` BOOLEAN NOT NULL,
    `email` BOOLEAN NOT NULL,
    `ignore` tinyint(1) NOT NULL,
    `status` tinyint(1) NOT NULL,
    PRIMARY KEY (`id`)
  ) ENGINE=$dbEngineISAM DEFAULT CHARSET=utf8;";
dbDelta($sql);
$sql = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."push_events_queue` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `post_id` int(11) NOT NULL,
    `old_status` varchar(50) NOT NULL,
    `new_status` varchar(50) NOT NULL,
    `post` mediumtext NOT NULL,
    `pushtime` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (`id`)
  ) ENGINE=$dbEngineISAM DEFAULT CHARSET=utf8;";
dbDelta($sql);
$wpdb->query("ALTER TABLE  `".$wpdb->prefix."push_relation` ADD  `connection_id` INT NOT NULL");
$wpdb->query("UPDATE `".$wpdb->prefix."push_relation` SET `connection_id`='1'");
$chancount = $wpdb->get_var("SELECT id FROM `".$wpdb->prefix."push_channels` WHERE id='1'");
if(!$chancount){
  $wpdb->query("INSERT INTO `".$wpdb->prefix."push_channels` (`id`, `title`, `private`, `default`) VALUES (1, '".__('Main Channel', 'smpush-plugin-lang')."', 0, 1);");
}

$sql = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."push_connection` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL,
  `description` mediumtext NOT NULL,
  `dbtype` enum('localhost','remote') NOT NULL,
  `dbhost` varchar(50) NOT NULL DEFAULT 'localhost',
  `dbname` varchar(50) NOT NULL,
  `dbuser` varchar(50) NOT NULL,
  `dbpass` varchar(50) NOT NULL,
  `tbname` varchar(50) NOT NULL,
  `id_name` varchar(50) NOT NULL,
  `token_name` varchar(50) NOT NULL,
  `md5token_name` varchar(50) NOT NULL,
  `type_name` varchar(50) NOT NULL,
  `ios_name` varchar(20) NOT NULL,
  `iosfcm_name` varchar(20) NOT NULL,
  `android_name` varchar(20) NOT NULL,
  `wp_name` varchar(20) NOT NULL,
  `bb_name` varchar(20) NOT NULL,
  `chrome_name` varchar(20) NOT NULL,
  `safari_name` varchar(20) NOT NULL,
  `firefox_name` varchar(20) NOT NULL,
  `opera_name` varchar(20) NOT NULL,
  `edge_name` varchar(20) NOT NULL,
  `samsung_name` varchar(20) NOT NULL,
  `fbmsn_name` varchar(20) NOT NULL,
  `fbnotify_name` varchar(20) NOT NULL,
  `email_name` varchar(20) NOT NULL,
  `wp10_name` varchar(20) NOT NULL,
  `info_name` VARCHAR(50) NOT NULL,
  `latitude_name` VARCHAR(50) NOT NULL,
  `longitude_name` VARCHAR(50) NOT NULL,
  `gpstime_name` VARCHAR(50) NOT NULL,
  `geotimeout_name` VARCHAR(50) NOT NULL,
  `postdate` VARCHAR(20) NOT NULL,
  `counter_name` VARCHAR(20) NOT NULL,
  `active_name` VARCHAR( 20 ) NOT NULL,
  `counter` int(11) NOT NULL,
  PRIMARY KEY (`id`)
  ) ENGINE=$dbEngineISAM DEFAULT CHARSET=utf8;";
dbDelta($sql);

$sql = "CREATE TABLE `".$wpdb->prefix."push_history` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `msgid` int(11) NOT NULL,
    `userid` int(11) NOT NULL,
    `platform` varchar(10) NOT NULL,
    `timepost` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (`id`)
  ) ENGINE=$dbEngineINNO DEFAULT CHARSET=utf8;";
dbDelta($sql);

$sql = "CREATE TABLE IF NOT EXISTS `".$wpdb->prefix."push_desktop_messages` (
    `msgid` int(11) NOT NULL,
    `token` varchar(32) NOT NULL,
    `type` varchar(10) NOT NULL,
    `timepost` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP
  ) ENGINE=$dbEngineINNO DEFAULT CHARSET=utf8;";
dbDelta($sql);

$wpdb->insert($wpdb->prefix.'push_connection', array(
  'title' => __('Default Connection', 'smpush-plugin-lang'),
  'description' => __('Plugin default connection', 'smpush-plugin-lang'),
  'dbtype' => 'localhost',
  'tbname' => '{wp_prefix}push_tokens',
  'id_name' => 'id',
  'token_name' => 'device_token',
  'md5token_name' => 'md5device_token',
  'type_name' => 'device_type',
  'ios_name' => 'ios',
  'iosfcm_name' => 'iosfcm',
  'android_name' => 'android',
  'wp_name' => 'wp',
  'bb_name' => 'bb',
  'chrome_name' => 'chrome',
  'safari_name' => 'safari',
  'firefox_name' => 'firefox',
  'opera_name' => 'opera',
  'edge_name' => 'edge',
  'samsung_name' => 'samsung',
  'fbmsn_name' => 'fbmsn',
  'fbnotify_name' => 'fbnotify',
  'email_name' => 'email',
  'wp10_name' => 'wp10',
  'info_name' => 'information',
  'latitude_name' => 'latitude',
  'longitude_name' => 'longitude',
  'gpstime_name' => 'gps_time_update',
  'geotimeout_name' => 'last_geomsg_time',
  'postdate' => 'timepost',
  'counter_name' => 'counter',
  'active_name' => 'active',
  'counter' => '0',
));

$wpdb->insert($wpdb->prefix.'push_events', array('title' => __('Notify all members when administrator published a new post', 'smpush-plugin-lang'), 'event_type' => 'publish', 'post_type' => 'post', 'subject' => __('We have published a new topic', 'smpush-plugin-lang'), 'message' => '{$post_title}', 'notify_segment' => 'all', 'subs_filter' => 'all', 'desktop_link' => 1, 'status' => 1));
$wpdb->insert($wpdb->prefix.'push_events', array('title' => __('Notify author when administrator approved and published his post', 'smpush-plugin-lang'), 'event_type' => 'approve', 'post_type' => 'post', 'subject' => __('Your post is approved and published', 'smpush-plugin-lang'), 'message' => '{$post_title}', 'notify_segment' => 'post_owner', 'subs_filter' => 'all', 'desktop_link' => 1, 'status' => 1));
$wpdb->insert($wpdb->prefix.'push_events', array('title' => __('Notify all users subscribed in a post when has got a new update', 'smpush-plugin-lang'), 'event_type' => 'update', 'post_type' => 'post', 'subject' => __('The post you subscribed in got new updates', 'smpush-plugin-lang'), 'message' => '{$post_title}', 'notify_segment' => 'post_commenters', 'subs_filter' => 'all', 'desktop_link' => 1, 'status' => 1));

$sql = "CREATE TABLE `".$wpdb->prefix."push_autorss_data` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `sourceid` int(11) NOT NULL,
    `campid` int(11) NOT NULL,
    `subject` varchar(200) NOT NULL,
    `content` text NOT NULL,
    `link` text NOT NULL,
    `md5link` varchar(32) NOT NULL,
    `published` tinyint(1) NOT NULL,
    PRIMARY KEY (`id`)
  ) ENGINE=$dbEngineISAM DEFAULT CHARSET=utf8;";
dbDelta($sql);

$sql = "CREATE TABLE `".$wpdb->prefix."push_autorss_sources` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `campid` int(11) NOT NULL,
    `title` varchar(150) NOT NULL,
    `link` text NOT NULL,
    `text_limit` int(11) NOT NULL,
    `read_limit` int(11) NOT NULL,
    `read_status` tinyint(1) NOT NULL,
    `read_error` text NOT NULL,
    `lastupdate` varchar(15) NOT NULL,
    `data_counter` int(11) NOT NULL,
    `active` tinyint(1) NOT NULL,
    PRIMARY KEY (`id`)
  ) ENGINE=$dbEngineISAM DEFAULT CHARSET=utf8;";
dbDelta($sql);

$wpdb->query("CREATE TABLE `".$wpdb->prefix."push_newsletter_templates` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `msgid` int(11) NOT NULL,
    `title` varchar(150) NOT NULL,
    `template` text NOT NULL,
    `static` tinyint(1) NOT NULL,
    PRIMARY KEY (`id`)
  ) ENGINE=$dbEngineISAM DEFAULT CHARSET=utf8;");
$wpdb->query("INSERT INTO `".$wpdb->prefix."push_newsletter_templates` (`id`, `msgid`, `title`, `template`, `static`) VALUES
    (1, 0, 'Basic Ecommerce', 'BF-basic-e-commerce', 1),
    (2, 0, 'Basic Newsletter', 'BF-basic-newsletter', 1),
    (3, 0, 'Basic Onecolumn', 'BF-basic-onecolumn', 1),
    (4, 0, 'Basic Standard', 'BF-basic-standard', 1),
    (5, 0, 'Blank Template', 'BF-blank-template', 1),
    (6, 0, 'Ecommerce Template', 'BF-ecommerce-template', 1),
    (7, 0, 'Newsletter Template', 'BF-newsletter-template', 1),
    (8, 0, 'Promo Template', 'BF-promo-template', 1),
    (9, 0, 'Simple Template', 'BF-simple-template', 1);");

$wpdb->query("CREATE TABLE `".$wpdb->prefix."push_newsletter_views` (
    `id` int(11) NOT NULL AUTO_INCREMENT,
    `msgid` int(11) NOT NULL,
    `platid` smallint(6) NOT NULL,
    `deviceid` int(11) NOT NULL,
    `action` varchar(10) NOT NULL,
    `timepost` timestamp NULL DEFAULT CURRENT_TIMESTAMP,
    PRIMARY KEY (`id`)
  ) ENGINE=$dbEngineINNO DEFAULT CHARSET=utf8;");

$wpdb->query("CREATE TABLE `".$wpdb->prefix."push_subscriptions` (
    `userid` int(11) NOT NULL,
    `keywords` varchar(200) NOT NULL,
    `categories` varchar(200) NOT NULL,
    `latitude` decimal(10,8) DEFAULT NULL,
    `longitude` decimal(11,8) DEFAULT NULL,
    `radius` smallint(6) NOT NULL,
    `web` tinyint(1) NOT NULL,
    `mobile` tinyint(1) NOT NULL,
    `msn` tinyint(1) NOT NULL,
    `email` tinyint(1) NOT NULL,
    PRIMARY KEY (`userid`)
  ) ENGINE=$dbEngineINNO DEFAULT CHARSET=utf8;");

$setting = array(
  'auth_key' => smpush_helper::saltHash(15),
  'complex_auth' => 0,
  'push_basename' => 'push',
  'def_connection' => 1,
  'apple_sandbox' => 0,
  'stop_summarize' => 0,
  'msgs_interval' => 0,
  'gmaps_apikey' => '',
  'apple_passphrase' => '',
  'apple_cert_path' => '',
  'apple_appid' => '',
  'apple_api_ver' => 'ssl',
  'apple_cert_type' => 'pem',
  'apple_certp8_path' => '',
  'apple_teamid' => '',
  'apple_keyid' => '',
  'ios_onebyone' => 0,
  'desktop_paytoread_message' => '',
  'desktop_welc_status' => 0,
  'desktop_welc_title' => '',
  'desktop_welc_message' => '',
  'desktop_welc_icon' => '',
  'desktop_welc_link' => '',
  'desktop_welc_redir_link' => '',
  'desktop_welc_redir' => 0,
  'google_apikey' => '',
  'chrome_apikey' => '',
  'chrome_manifest' => '',
  'desktop_offline' => '0',
  'desktop_status' => '0',
  'desktop_debug' => '0',
  'desktop_request_type' => 'popup',
  'desktop_logged_only' => '0',
  'desktop_modal_title' => __('Keep me posted', 'smpush-plugin-lang'),
  'desktop_modal_message' => __('Give us a permission to sending you push notification messages and we will keep you posted !', 'smpush-plugin-lang'),
  'safari_web_id' => '',
  'desktop_popup_layout' => 'flat',
  'desktop_popupicon' => '',
  'desktop_showin_pageids' => '',
  'desktop_btn_subs_text' => __('Subscribe', 'smpush-plugin-lang'),
  'desktop_btn_unsubs_text' => __('Unsubscribe', 'smpush-plugin-lang'),
  'desktop_modal_cancel_text' => __('Ignore', 'smpush-plugin-lang'),
  'desktop_modal_saved_text' => __('Saved', 'smpush-plugin-lang'),
  'desktop_deficon' => '',
  'desktop_notsupport_msg' => '',
  'desktop_paytoread_darkness' => 9,
  'desktop_paytoread_textsize' => '',
  'desktop_paytoread_substext' => '',
  'desktop_chrome_status' => '0',
  'desktop_edge_status' => '0',
  'chrome_projectid' => '',
  'desktop_firefox_status' => '0',
  'desktop_safari_status' => '0',
  'safari_cert_path' => '',
  'safari_certp12_path' => '',
  'safari_icon' => '',
  'safari_passphrase' => '',
  'ios_titanium_payload' => 0,
  'android_titanium_payload' => 0,
  'purchase_code' => '',//do not steal so you have honor
  'vip' => 0,//do not steal so you have honor
  'wp_authed' => '0',
  'wp_cert' => '',
  'wp_pem' => '',
  'wp10_pack_sid' => '',
  'wp10_client_secret' => '',
  'wp_cainfo' => '',
  'bb_appid' => '',
  'bb_password' => '',
  'bb_cpid' => '',
  'bb_dev_env' => 0,
  'android_corona_payload' => 0,
  'geo_provider' => 'ip-api.com',
  'db_ip_apikey' => '',
  'auto_geo' => 0,
  'cron_limit' => 0,
  'e_post_chantocats' => 0,
  'e_appcomment' => 0,
  'e_newcomment' => 0,
  'e_usercomuser' => 0,
  'e_appcomment_body' => __('Your comment "{comment}" is approved and published now', 'smpush-plugin-lang'),
  'e_newcomment_body' => __('Your post "{subject}" have new comments, Keep in touch with your readers', 'smpush-plugin-lang'),
  'e_usercomuser_body' => __('Someone reply on your comment "{comment}"', 'smpush-plugin-lang'),
  'e_newcomment_allusers' => 0,
  'e_newcomment_allusers_body' => __('Notify all users that commented on a post when adding a new comment on this post', 'smpush-plugin-lang'),
  'e_newcomment_mentions' => 0,
  'e_newcomment_mentions_body' => __('Someone mention you in comment "{comment}"', 'smpush-plugin-lang'),
  'metabox_check_status' => 0,
  'bb_notify_friends' => 0,
  'bb_notify_messages' => 0,
  'bb_notify_activity' => 0,
  'bb_notify_activity_admins_only' => 0,
  'bb_notify_xprofile' => 0,
  'ios_badge' => '',
  'ios_launch' => '',
  'ios_sound' => 'default',
  'android_fcm_msg' => 0,
  'android_title' => '',
  'android_icon' => '',
  'android_sound' => 'default',
  'desktop_title' => '',
  'desktop_popup_position' => 'center',
  'desktop_icon_message' => __('Give us a permission to receive push notification messages and we will keep you posted !', 'smpush-plugin-lang'),
  'desktop_icon_unsubs_text' => __('Unsubscribe from receiving our notifications and delete your subscription', 'smpush-plugin-lang'),
  'desktop_icon_position' => 'bottomright',
  'desktop_iconimage' => '',
  'desktop_popup_css' => '',
  'desktop_delay' => 0,
  'desktop_admins_only' => 0,
  'desktop_gps_status' => 0,
  'desktop_paytoread' => 0,
  'desktop_reqagain' => 3,
  'desktop_run_places' => array(0 => 'all'),
  'desktop_opera_status' => '0',
  'desktop_samsung_status' => '0',
  'msn_verify' => rand(10000,20000),
  'msn_appid' => '',
  'msn_secret' => '',
  'msn_oldaccesstoken' => '',
  'msn_accesstoken' => '',
  'msn_subscribe_error' => '',
  'msn_widget_title' => __('Send us a message on Facebook', 'smpush-plugin-lang'),
  'fbnotify_appid' => '',
  'fbnotify_secret' => '',
  'fbnotify_applink' => '',
  'fbnotify_method' => 'iframe',
  'fbnotify_width' => '',
  'fbnotify_height' => '',
  'smtp_status' => 0,
  'smtp_host' => '',
  'smtp_port' => '',
  'smtp_username' => '',
  'smtp_password' => '',
  'msn_woo_checkout' => 0,
  'msn_woo_cartbtn' => 0,
  'msn_widget_status' => 0,
  'msn_fbpage_link' => '',
  'msn_lang' => 'en_US',
  'msn_official_widget_status' => 0,
  'msn_official_fbpage_id' => '',
  'msn_subs_command' => 'subscribe me',
  'msn_unsubs_command' => 'unsubscribe and delete my account',
  'msn_btn_fblink' => '',
  'msn_btn_text' => __('Send us message', 'smpush-plugin-lang'),
  'msn_btn_width' => 160,
  'msn_btn_height' => 40,
  'msn_btn_color' => '#fff',
  'msn_btn_bgcolor' => '#0084ff',
  'msn_btn_icon' => smpush_imgpath.'/messenger_w.png',
  'fblogin_btn_redirect' => '',
  'fblogin_btn_text' => __('Login With Facebook', 'smpush-plugin-lang'),
  'fblogin_btn_width' => 205,
  'fblogin_btn_height' => 40,
  'fblogin_btn_color' => '#fff',
  'fblogin_btn_bgcolor' => '#0084ff',
  'fblogin_btn_icon' => smpush_imgpath.'/facebook_w.png',
  'fblogin_regin_newsletter' => 1,
  'fblogin_regin_fbnotifs' => 0,
  'fblogin_regin_wpuser' => 1,
  'e_wpjobman_status' => 0,
  'e_wpjobman_body' => __('You have ({counter}) job offers waiting you for ({alert}) alert, good luck!', 'smpush-plugin-lang'),
  'subspage_geo_status' => 0,
  'subspage_geo_lat' => '',
  'subspage_geo_lng' => '',
  'subspage_geo_acf' => '',
  'subspage_keywords' => 1,
  'subspage_channels' => 1,
  'subspage_cats_status' => 1,
  'subspage_plat_web' => 1,
  'subspage_plat_mobile' => 1,
  'subspage_plat_msn' => 1,
  'subspage_plat_email' => 1,
  'subspage_applink_play' => '',
  'subspage_applink_ios' => '',
  'subspage_applink_wp' => '',
  'subspage_post_type' => 'post',
  'subspage_post_type_tax' => 'category',
  'subspage_category' => array(),
  'subspage_matchone' => 0,
  'subspage_show_catimages' => 1,
  'gdpr_termslink' => '',
  'gdpr_privacylink' => '',
  'gdpr_icon' => 0,
  'gdpr_subs_btn' => 0,
  'gdpr_ver_option' => 0,
  'gdpr_ver_text' => __('By proceeding in this form you will receive our marketing notifications and agree to our #Privacy Policy# and #Terms of Use#', 'smpush-plugin-lang'),
  'fast_bridge' => 1,
  'uninstall_action' => 'files',
  'last_change_time' => time(),
);

$setting['android_msg_counter'] = 0;
$setting['ios_msg_counter'] = 0;
$setting['e_woo_waiting'] = 0;
$setting['e_woo_waiting_title'] = __('{title} in stock !', 'smpush-plugin-lang');
$setting['e_woo_waiting_message'] = __('catch your waiting product now is available again with price ${price}', 'smpush-plugin-lang');
$setting['e_woo_abandoned'] = 0;
$setting['e_woo_aband_maxage'] = 24;
$setting['e_woo_aband_times'] = 3;
$setting['e_woo_aband_interval'] = 72;
$setting['e_woo_aband_title'] = __('{customer_name} do not miss your cart !', 'smpush-plugin-lang');
$setting['e_woo_aband_message'] = __('we saved {productscount} items cart but quantities are limited. click here to complete your order', 'smpush-plugin-lang');
$setting['e_woo_aband_last_rem'] = 0;
$setting['e_woo_aband_last_title'] = __('{customer_name} the last call !', 'smpush-plugin-lang');
$setting['e_woo_aband_last_message'] = __('click here and complete now your order with this special coupon', 'smpush-plugin-lang');

add_option('smpush_options', $setting);
add_option('smpush_version', SMPUSHVERSION);
add_option('smpush_instant_send', array());
add_option('smpush_cron_stats', array());
add_option('smpush_stats', array());
add_option('smpush_history', '');

$wp_rewrite->flush_rules(false);
smpush_controller::setup_htaccess();

if($blog_id !== false){
  restore_current_blog();
}